"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Decs_1 = require("../types/Decs");
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
let _Fs = class _Fs {
    rmFile(filePath) {
        if (filePath instanceof Array) {
            return filePath.map((path) => this.rmFile(path));
        }
        else {
            fs_1.default.unlinkSync(filePath);
            return true;
        }
    }
    mkFile(path, data) {
        fs_1.default.writeFileSync(path, data, {});
        return true;
    }
    rmDir(path) {
        if (!fs_1.default.existsSync(path))
            return false;
        const files = fs_1.default.readdirSync(path);
        files.forEach((file) => {
            let curPath = path + "\\" + file;
            if (fs_1.default.statSync(curPath).isDirectory()) {
                this.rmDir(curPath);
            }
            else {
                fs_1.default.unlinkSync(curPath);
            }
        });
        fs_1.default.rmdirSync(path);
        return true;
    }
    mkDir(path) {
        fs_1.default.mkdirSync(path);
        return true;
    }
    readDir(path, options) {
        return fs_1.default.readdirSync(path, options);
    }
    readFile(path, options) {
        return fs_1.default.readFileSync(path, options);
    }
    getFileNamsByDir(path, back = ["js"], skipDirNames = ["node_modules"]) {
        if (!fs_1.default.existsSync(path))
            return;
        const paths = [];
        const files = fs_1.default.readdirSync(path);
        files.forEach((file) => {
            let curPath = path_1.default.join(path, file);
            if (fs_1.default.statSync(curPath).isDirectory()) {
                if (skipDirNames.includes(file))
                    return;
                const list = this.getFileNamsByDir(curPath, back, skipDirNames);
                if (list === undefined)
                    return;
                paths.push(...list);
            }
            else {
                if (file.substring(0, 1) === ".")
                    return;
                if (back) {
                    const pathBack = curPath
                        .substr(curPath.lastIndexOf(".") + 1)
                        .toLowerCase();
                    if (back.includes(pathBack))
                        paths.push(curPath);
                }
                else {
                    paths.push(curPath);
                }
            }
        });
        return paths;
    }
    getAllFileNamsByDir(path) {
        if (!fs_1.default.existsSync(path))
            return;
        const paths = [];
        const files = this.readDir(path);
        console.log(files, "files");
        files.map((file) => {
            let curPath = path_1.default.join(path, file);
            if (this.isDir(curPath)) {
                const list = this.getAllFileNamsByDir(curPath);
                if (list)
                    paths.push(...list);
            }
            paths.push(curPath);
        });
        return paths;
    }
    isHas(path) {
        return fs_1.default.existsSync(path);
    }
    getFileInfo(path) {
        if (!this.isHas(path))
            return false;
        const info = fs_1.default.statSync(path);
        return info;
    }
    isDir(path) {
        if (path instanceof Array) {
            for (const p of path) {
                if (!this.isDir(p))
                    return false;
            }
            return true;
        }
        else {
            const info = this.getFileInfo(path);
            if (!info)
                return false;
            return info.isDirectory();
        }
    }
    copyDirToDir(formDir, toDir, skips = ["node_modules"]) {
        const pms = [];
        if (!this.isDir(formDir))
            throw TypeError("路径为空");
        if (!this.isDir(toDir))
            this.mkDir(toDir);
        const files = this.readDir(formDir);
        files.map((path) => {
            if (skips.includes(path))
                return;
            const _src = formDir + "\\" + path;
            const _dst = toDir + "\\" + path;
            let readable;
            let writable;
            const srcInfo = this.getFileInfo(_src);
            if (srcInfo.isFile()) {
                const copyPms = new Promise((s) => {
                    readable = fs_1.default.createReadStream(_src);
                    writable = fs_1.default.createWriteStream(_dst);
                    readable.pipe(writable);
                    readable.on("end", () => {
                        s(0);
                    });
                });
                pms.push(copyPms);
            }
            else if (srcInfo.isDirectory()) {
                const childPms = this.copyDirToDir(_src, _dst);
                pms.push(...childPms);
            }
        });
        return pms;
    }
};
_Fs = __decorate([
    (0, Decs_1.CatchClass)(false)
], _Fs);
exports.default = _Fs;
